unit JCDes1;

{$N-}   { ᯮ짮+ ᫮ ᮯ ( 窠)            }
{$E-}   { + (⪫-) ० 樨 ᮯ              }

{$IFDEF Ver70}
{$P-}   { Open String Parameters Swich                                    }
{$Q-}   { + (⪫-) ஫ ९ . .       }
{$T-}   { ஫ @, ⨯஢-, ⨯஢+         }
{$ENDIF}

{$A+}   { ࠢ   ࠭ ᫮+ (-)                   }
{$B-}   {  ᪨ ࠦ +                       }
{$D-}   { +, (-) ࠡ  ஥ ⫠稪        }
{$F-}   { ᯮ짮 + (-)  맮                  }
{$G+}   { ᯮ짮  +  I80286,  I8088 -           }
{$I-}   { + (⪫-) ஫ 権 -뢮           }
{$L-}   { + (⪫-)  ᨬ  ⫠稪          }
{$O-}   { + (p-)ᮧ ૥             }
{$R-}   { + (⪫-) ஫                        }
{$S-}   { + (⪫-) ஫ ९ ⥪              }
{$V-}   { + (⪫-) ஫  ப                     }
{$X-}   { ᯮ짮+ ( ᯮ짮-) ७ ᨭ⠪          }

  interface

    const
      MaxInd = 8;           { 64 Bits block (8 bytes)                     }
    type
      DArray  = array[1..MaxInd] of char;                  {  8 Chars     }

    procedure DES(const INP : DArray; const Key : DArray; var OUT : DArray);

  implementation

    type
      Array1  = array[1..MaxInd * MaxInd] of byte;         { 64 Bytes     }
      Array21 = array[1..MaxInd - 1] of char;              {  7 Chars     }
      Array3  = array[1..MaxInd * (MaxInd - 2)] of byte;   { 48 Bytes     }
      Array31 = array[1..MaxInd - 2] of char;              {  6 Chars     }
      Array4  = array[1..MaxInd * (MaxInd - 4)] of byte;   { 32 Bytes     }
      Array41 = array[1..MaxInd - 4] of char;              {  4 Chars     }
      Array5  = array[1..MaxInd * (MaxInd - 1)] of byte;   { 56 Bytes     }
      Array6  = array[1..MaxInd * 2] of byte;              { 16 Bytes     }

    const
      IP   : Array1 = (58, 50, 42, 34, 26, 18, 10, 02,
                       60, 52, 44, 36, 28, 20, 12, 04,
                       62, 54, 46, 38, 30, 22, 14, 06,
                       64, 56, 48, 40, 32, 24, 16, 08,
                       57, 49, 41, 33, 25, 17, 09, 01,
                       59, 51, 43, 35, 27, 19, 11, 03,
                       61, 53, 45, 37, 29, 21, 13, 05,
                       63, 55, 47, 39, 31, 23, 15, 07);

      IP_1 : Array1 = (40, 08, 48, 16, 56, 24, 64, 32,
                       39, 07, 47, 15, 55, 23, 63, 31,
                       38, 06, 46, 14, 54, 22, 62, 30,
                       37, 05, 45, 13, 53, 21, 61, 29,
                       36, 04, 44, 12, 52, 20, 60, 28,
                       35, 03, 43, 11, 51, 19, 59, 27,
                       34, 02, 42, 10, 50, 18, 58, 26,
                       33, 01, 41, 09, 49, 17, 57, 25);

      StE  : Array1 = (01, 02, 03, 04, 05, 06, 07, 08,
                       07, 08, 09, 10, 11, 12, 15, 16,
                       13, 14, 15, 16, 17, 18, 23, 24,
                       19, 20, 21, 22, 23, 24, 31, 32,
                       25, 26, 27, 28, 29, 30, 39, 40,
                       31, 32, 33, 34, 35, 36, 47, 48,
                       37, 38, 39, 40, 41, 42, 07, 08,
                       43, 44, 45, 46, 47, 48, 15, 16);

      E    : Array3 = (32, 01, 02, 03, 04, 05,
                       04, 05, 06, 07, 08, 09,
                       08, 09, 10, 11, 12, 13,
                       12, 13, 14, 15, 16, 17,
                       16, 17, 18, 19, 20, 21,
                       20, 21, 22, 23, 24, 25,
                       24, 25, 26, 27, 28, 29,
                       28, 29, 30, 31, 32, 01);

      S1   : Array1 = (14, 04, 13, 01, 02, 15, 11, 08, 03, 10, 06, 12, 05, 09, 00, 07,
                       00, 15, 07, 04, 14, 02, 13, 01, 10, 06, 12, 11, 09, 05, 03, 08,
                       04, 01, 14, 08, 13, 06, 02, 11, 15, 12, 09, 07, 03, 10, 05, 00,
                       15, 12, 08, 02, 04, 09, 01, 07, 05, 11, 03, 14, 10, 00, 06, 13);

      S2   : Array1 = (15, 01, 08, 14, 06, 11, 03, 04, 09, 07, 02, 13, 12, 00, 05, 10,
                       03, 13, 04, 07, 15, 02, 08, 14, 12, 00, 01, 10, 06, 09, 11, 05,
                       00, 14, 07, 11, 10, 04, 13, 01, 05, 08, 12, 06, 09, 03, 02, 15,
                       13, 08, 10, 01, 03, 15, 04, 02, 11, 06, 07, 12, 00, 05, 14, 09);

      S3   : Array1 = (10, 00, 09, 14, 06, 03, 15, 05, 01, 13, 12, 07, 11, 04, 02, 08,
                       13, 07, 00, 09, 03, 04, 06, 10, 02, 08, 05, 14, 12, 11, 15, 01,
                       13, 06, 04, 09, 08, 15, 03, 00, 11, 01, 02, 12, 05, 10, 14, 07,
                       01, 10, 13, 00, 06, 09, 08, 07, 04, 15, 14, 03, 11, 05, 02, 12);

      S4   : Array1 = (07, 13, 14, 03, 00, 06, 09, 10, 01, 02, 08, 05, 11, 12, 04, 15,
                       13, 08, 11, 05, 06, 15, 00, 03, 04, 07, 02, 12, 01, 10, 14, 09,
                       10, 06, 09, 00, 12, 11, 07, 13, 15, 01, 03, 14, 05, 02, 08, 04,
                       03, 15, 00, 06, 10, 01, 13, 08, 09, 04, 05, 11, 12, 07, 02, 14);

      S5   : Array1 = (02, 12, 04, 01, 07, 10, 11, 06, 08, 05, 03, 15, 13, 00, 14, 09,
                       14, 11, 02, 12, 04, 07, 13, 01, 05, 00, 15, 10, 03, 09, 08, 06,
                       04, 02, 01, 11, 10, 13, 07, 08, 15, 09, 12, 05, 06, 03, 00, 14,
                       11, 08, 12, 07, 01, 14, 02, 13, 06, 15, 00, 09, 10, 04, 05, 03);

      S6   : Array1 = (12, 01, 10, 15, 09, 02, 06, 08, 00, 13, 03, 04, 14, 07, 05, 11,
                       10, 15, 04, 02, 07, 12, 09, 05, 06, 01, 13, 14, 00, 11, 03, 08,
                       09, 14, 15, 05, 02, 08, 12, 03, 07, 00, 04, 10, 01, 13, 11, 06,
                       04, 03, 02, 12, 09, 05, 15, 10, 11, 14, 01, 07, 06, 00, 08, 13);

      S7   : Array1 = (04, 11, 02, 14, 15, 00, 08, 13, 03, 12, 09, 07, 05, 10, 06, 01,
                       13, 00, 11, 07, 04, 09, 01, 10, 14, 03, 05, 12, 02, 15, 08, 06,
                       01, 04, 11, 13, 12, 03, 07, 14, 10, 15, 06, 08, 00, 05, 09, 02,
                       06, 11, 13, 08, 01, 04, 10, 07, 09, 05, 00, 15, 14, 02, 03, 12);

      S8   : Array1 = (13, 02, 08, 04, 06, 15, 11, 01, 10, 09, 03, 14, 05, 00, 12, 07,
                       01, 15, 13, 08, 10, 03, 07, 04, 12, 05, 06, 11, 00, 14, 09, 02,
                       07, 11, 04, 01, 09, 12, 14, 02, 00, 06, 10, 13, 15, 03, 05, 08,
                       02, 01, 14, 07, 04, 10, 08, 13, 15, 12, 09, 00, 03, 05, 06, 11);

      P    : Array4 = (16, 07, 20, 21,
                       29, 12, 28, 17,
                       01, 15, 23, 26,
                       05, 18, 31, 10,
                       02, 08, 24, 14,
                       32, 27, 03, 09,
                       19, 13, 30, 06,
                       22, 11, 04, 25);

      PC_1 : Array5 = (57, 49, 41, 33, 25, 17, 09,
                       01, 58, 50, 42, 34, 26, 18,
                       10, 02, 59, 51, 43, 35, 27,
                       19, 11, 03, 60, 52, 44, 36,
                       63, 55, 47, 39, 31, 23, 15,
                       07, 62, 54, 46, 38, 30, 22,
                       14, 06, 61, 53, 45, 37, 29,
                       21, 13, 05, 28, 20, 12, 04);

      PC_2 : Array3 = (14, 17, 11, 24, 01, 05,
                       03, 28, 15, 06, 21, 10,
                       23, 19, 12, 04, 26, 08,
                       16, 07, 27, 20, 13, 02,
                       41, 52, 31, 37, 47, 55,
                       30, 40, 51, 45, 33, 48,
                       44, 49, 39, 56, 34, 53,
                       46, 42, 50, 36, 29, 32);

      LS   : Array6 = (01, 01, 02, 02, 02, 02, 02, 02,
                       01, 02, 02, 02, 02, 02, 02, 01);

    { Input & Output Registers                                            }
    { Input                                                               }
    {         AL = Index                                                  }
    { Output                                                              }
    {         BL = NByte                                                  }
    {         BH = Bit                                                    }
    procedure GetValues; near; assembler;
      asm
        MOV     BL,0                          { BL = NByte = 0            }
        CMP     AL,8                          { case Index of             }
        JA      @@1
        MOV     BL,0
        JMP     @@8
@@1:    CMP     AL,16
        JA      @@2
        MOV     BL,1
        JMP     @@8
@@2:    CMP     AL,24
        JA      @@3
        MOV     BL,2
        JMP     @@8
@@3:    CMP     AL,32
        JA      @@4
        MOV     BL,3
        JMP     @@8
@@4:    CMP     AL,40
        JA      @@5
        MOV     BL,4
        JMP     @@8
@@5:    CMP     AL,48
        JA      @@6
        MOV     BL,5
        JMP     @@8
@@6:    CMP     AL,56
        JA      @@7
        MOV     BL,6
        JMP     @@8
@@7:    MOV     BL,7
@@8:    PUSH    AX
        XOR     AH,AH                         { AH = 0                    }
        MOV     BH,8                          { BH = MaxInd = 8           }
        DIV     BH                            { AH = AX mod MaxInd        }
        CMP     AH,0                          { AH = 0 ?                  }
        JNE     @@9
        MOV     AH,8                          { if AH = 0 => AH = 8       }
@@9:    MOV     BH,AH
        POP     AX                            { AL = Index                }
      end;

    { Input & Output Registers                                            }
    { Input                                                               }
    {        AL    = Index                                                }
    {        ES:DI = Block                                                }
    { Output                                                              }
    {        AL    = ReadBit                                              }
    function ReadBit : byte; near; assembler;
      asm
        PUSH    BX                              { Save BX                 }
        PUSH    CX                              { Save CX                 }
        PUSH    DX                              { Save DX                 }
        XOR     AH,AH                           { AL = Index, AH = 0      }
        CALL    GetValues                       { BL = NByte, BH = Bit    }
        MOV     CL,BH                           { CL = BH = Bit           }
        XOR     BH,BH                           { BH = 0 => BX = NByte    }
        CMP     CL,1                            { Case Bit = CL of        }
        JA      @@1
        MOV     DL,128
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@1:    CMP     CL,2
        JA      @@2
        MOV     DL,64
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@2:    CMP     CL,3
        JA      @@3
        MOV     DL,32
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@3:    CMP     CL,4
        JA      @@4
        MOV     DL,16
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@4:    CMP     CL,5
        JA      @@5
        MOV     DL,8
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@5:    CMP     CL,6
        JA      @@6
        MOV     DL,4
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@6:    CMP     CL,7
        JA      @@7
        MOV     DL,2
        MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,DL
        DIV     DL
        JMP     @@8
@@7:    MOV     AL,BYTE PTR ES:[DI+BX]          { AL = Block[NByte = BX]  }
        AND     AL,1
@@8:    POP     DX
        POP     CX
        POP     BX
      end;

    { Input & Output Registers                                            }
    { Input                                                               }
    {        AL    = Index                                                }
    {        AH    = WrBit                                                }
    {        DS:SI = Block                                                }
    { Output                                                              }
    {        DS:SI = Block                                                }
    procedure WriteBit; near; assembler;
      asm
        PUSH    BX                              { Save BX                 }
        PUSH    CX                              { Save CX                 }
        CALL    GetValues                       { BL = NByte, BH = Bit    }
        MOV     CL,BH                           { CL = BH = Bit           }
        XOR     BH,BH                           { BH = 0 => BX = NByte    }
        CMP     CL,1                            { Case CL = Bit of        }
        JA      @@1
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@01
        OR      AL,128
        JMP     @@02
@@01:   AND     AL,127
@@02:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@1:    CMP     CL,2
        JA      @@2
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@11
        OR      AL,64
        JMP     @@12
@@11:   AND     AL,191
@@12:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@2:    CMP     CL,3
        JA      @@3
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@21
        OR      AL,32
        JMP     @@22
@@21:   AND     AL,223
@@22:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@3:    CMP     CL,4
        JA      @@4
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@31
        OR      AL,16
        JMP     @@32
@@31:   AND     AL,239
@@32:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@4:    CMP     CL,5
        JA      @@5
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@41
        OR      AL,8
        JMP     @@42
@@41:   AND     AL,247
@@42:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@5:    CMP     CL,6
        JA      @@6
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@51
        OR      AL,4
        JMP     @@52
@@51:   AND     AL,251
@@52:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@6:    CMP     CL,7
        JA      @@7
        MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@61
        OR      AL,2
        JMP     @@62
@@61:   AND     AL,253
@@62:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
        JMP     @@8
@@7:    MOV     AL,BYTE PTR DS:[SI+BX]          { AL = Block[NByte = BX]  }
        CMP     AH,1                            { AH = WrBit = 1 ?        }
        JNE     @@71
        OR      AL,1
        JMP     @@72
@@71:   AND     AL,254
@@72:   MOV     BYTE PTR DS:[SI+BX],AL          { Block[NByte = BX] = AL  }
@@8:    POP     CX
        POP     BX
      end;

    { Input & Output Registers                                            }
    { Input                                                               }
    {        ES:DI = Block                                                }
    {	     AX:DX = Matrix                                               }
    {	     CL    = High(Matrix) + 1                                     }
    { Output                                                              }
    {	     DS:SI = BlockOut                                             }
    procedure SwapBits; near; assembler;
      asm
	XOR	CH,CH			     { CH = 0, CX - 稪       }
@@1:	MOV	BX,CX			     { BX = CX = High(Matrix) + 1 }
	DEC	BX			     { BX = High(Matrix)          }
	PUSH	AX
	PUSH	ES
	PUSH	DI
	MOV	ES,AX
	MOV	DI,DX
        ADD     DI,BX
	MOV	AL,BYTE PTR ES:[DI]	     { AL = Index                 }
	POP	DI
	POP	ES
	CALL	ReadBit			     { AL = ReadBit               }
	MOV	AH,AL			     { AH = WrBit = AL            }
	MOV	AL,CL			     { Index = AL                 }
	CALL	WriteBit
	POP	AX
	LOOP	@@1
      end;

    { Input & Output Registers                                            }
    { Input                                                               }
    {	     AL    = Count                                                }
    {	     ES:DI = LSKey                                                }
    { Output                                                              }
    {	     DS:SI = Key                                                  }
    procedure ShlKey; near; assembler;
      var
        i, l : byte;
        Bit  : byte;
      asm
	XOR	AH,AH				{ AH = 0, => AX = Count   }
	DEC	AX
	ADD	DI,AX
	MOV	AL,BYTE PTR ES:[DI]		{ AL = LSKey[Count - 1]   }
	MOV	i,AL			        { i  = LSKey[Count - 1]   }
	MOV	AL,1
	CMP	AL,i
	JBE	@@1
	JMP	@@10
@@1:	MOV	BL,AL				{ BL = AL = i             }
	XOR	BH,BH
	JMP	@@3
@@2:	INC	BX				{ BX = i = i + 1          }
@@3:	MOV	Bit,0		                { Bit = 0                 }
	MOV	l,0		                { l = 0                   }
	MOV	CX,7				{ j = CX = 7              }
	MOV	AX,49				{ m = AX = 49 !!!         }
	JMP	@@6
@@5:	DEC	CX				{ j = CX = j - 1          }
@@6:	PUSH	AX
	MOV	DX,DS
	MOV	ES,DX				{ ES:DI = Key = DS:SI     }
	MOV	DI,SI
	CALL	ReadBit
	MOV	l,AL			        { l = AL                  }
	CMP	CL,4
	JNE	@@7
	MOV	AL,29				{ k = AL = 29             }
	CALL	ReadBit
	MOV	AH,AL				{ AH = WrBit = AL         }
	MOV	AL,56				{ AL = Index = 56         }
	CALL	WriteBit
@@7:	MOV	AL,CL				{ AL = CL = j             }
	XOR	AH,AH				{ AH = 0                  }
	DEC	AX
	PUSH	SI
	ADD	SI,AX
	MOV	DL,BYTE PTR DS:[SI]		{ DL = Key[j]             }
	XOR	DH,DH				{ DH = 0, => DX = Key[j]  }
	SHL	DX,1				{ DX = DX shl 1           }
	MOV	AL,Bit			        { AL = Bit                }
	XOR	AH,AH				{ AH = 0, => AX = Bit     }
	ADD	AX,DX
	MOV	BYTE PTR DS:[SI],AL
	POP	SI
	MOV	AL,l			        { AL = l                  }
	MOV	Bit,AL			        { Bit = AL = l            }
	CMP	CL,1				{ CL = j = 1 ?            }
	JNE	@@8			        { j <> 1                  }
	MOV	AL,28				{ k = AL = 28             }
	MOV	AH,Bit			        { AH = Bit                }
	CALL	WriteBit
@@8:    POP     AX
	SUB	AX,8
	CMP	CL,1
	JE	@@9
	JMP	@@5
@@9:	MOV	AL,BL
	CMP	AL,i
	JE	@@10
	JMP	@@2
@@10:
      end;

    { Input & Output Registers                                            }
    { Input                                                               }
    {	     ES:DI = SI                                                   }
    { Output                                                              }
    {	     DS:SI = RN                                                   }
    procedure FuncDes; near; assembler;
      var
        i     : word;
        Bit   : byte;
        Index : byte;
        RFF   : Array41;
      asm
        MOV     Bit,1
        MOV     CX,4
        MOV     AX,0
        PUSH    ES
        PUSH    DI
        LEA     DI,RFF
        REP     STOSB                   { RFF[i] = #0                     }
        POP     DI
        POP     ES
        MOV     i,0
        JMP     @@2
@@1:    INC     i
@@2:    PUSH    ES
        PUSH    DI
        MOV     AL,Bit
        CALL    ReadBit
        MOV     CL,AL
        SHL     CL,1
        MOV     AL,Bit
        ADD     AL,5
        CALL    ReadBit
        ADD     CL,AL                   { CL = ReadBit shl 1 + ReadBit    }
        MOV     AX,16
        MUL     CL                      { AX = 16*(ReadBit shl 1)+ReadBit }
        MOV	Index,AL
        MOV     AL,Bit
        ADD     AL,1
        CALL    ReadBit
        MOV     CX,3
        SHL     AX,CL
        ADD	Index,AL
        MOV	AL,Bit
        ADD	AL,2
        CALL	ReadBit
        MOV	CX,2
        SHL     AX,CL
        ADD     Index,AL
        MOV     AL,Bit
        ADD     AL,3
        CALL    ReadBit
        SHL     AL,1
        ADD     Index,AL
        MOV     AL,Bit
        ADD     AL,4
        CALL    ReadBit
        ADD     Index,AL
        INC     Index
        MOV     BL,Index
        DEC     BX
        XOR     BH,BH
        MOV     AX,0
        CMP     i,0
        JNE     @@3
        LEA     DI,S1
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@3:    CMP     i,1
        JNE     @@4
        LEA     DI,S2
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@4:    CMP     i,2
        JNE     @@5
        LEA     DI,S3
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@5:    CMP     i,3
        JNE     @@6
        LEA     DI,S4
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@6:    CMP     i,4
        JNE     @@7
        LEA     DI,S5
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@7:    CMP     i,5
        JNE     @@8
        LEA     DI,S6
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@8:    CMP     i,6
        JNE     @@9
        LEA     DI,S7
        MOV     BL,BYTE PTR ES:[DI+BX]
        JMP     @@10
@@9:    LEA     DI,S8
        MOV     BL,BYTE PTR ES:[DI+BX]  { BL = j                          }
@@10:   MOV     AX,i
        MOV     CX,2
        DIV     CL
        CMP     AH,0
        JNE     @@11
        MOV     DX,0                    { DL = k = 0                      }
@@11:   MOV     CX,4
        SHL     DX,CL
        ADD     DL,BL                   { DL = k = k shl 4 + j            }
        MOV     AX,i
        INC     AX
        MOV     CX,2
        DIV     CL
        CMP     AH,0
        JNE     @@12
        MOV     BX,i
        INC     BX
        SHR     BX,1
        LEA     DI,RFF
        MOV     BYTE PTR ES:[DI+BX-1],DL
@@12:   ADD     Bit,8
        POP     DI
        POP     ES
        CMP     i,7
        JNE     @@1
        MOV     AX,DS
        MOV     DX,OFFSET P
        LEA     DI,RFF
        MOV     CL,32
        CALL    SwapBits
      end;

    procedure DES(const INP : DArray; const Key : DArray; var OUT : DArray);
                  assembler;
      var
        AI, SSS       : DArray;
        Key_1,  Key_2 : Array21;
        Key_3,  RR    : Array31;
        R0, L0, RF    : Array41;
      asm
        PUSH    DS
        PUSH    SI
        { First swap bits in one 64 bits block                            }
        { First step : T0 = IP(T), T0 = AI, T = INP                       }
        MOV     AX,DS
        MOV     DX,OFFSET IP
        LES     DI,INP
        LEA     SI,AI
        MOV     CL,64
        CALL    SwapBits
        { Operations to convert 64 bits block to two 32 bits block: R0,L0 }
        MOV	BX,7
        JMP	@@2
@@1:    DEC	BX
@@2:	CMP	BX,3
	JBE	@@3
	MOV	DL,BYTE PTR DS:[SI+BX]
	LEA	DI,R0
	MOV	BYTE PTR ES:[DI+BX-4],DL
	JMP	@@4
@@3:	MOV	DL,BYTE PTR DS:[SI+BX]
	LEA	DI,L0
	MOV	BYTE PTR ES:[DI+BX],DL
@@4:	CMP	BX,0
	JNE	@@1
        { Delete control bits in Security Key                             }
        { 64 bits -------> 56 bits (Key_1)                                }
        MOV     DX,OFFSET PC_1
        LES     DI,Key
        LEA     SI,Key_1		{ DS:SI = Key_1                   }
        MOV     CL,56
        CALL    SwapBits
	{ MAIN 16 times circle                                            }
	LEA	DI,Key_2  		{ ES:DI = Key_2                   }
	MOV	CX,7
	REP	MOVSB           	{ Key_2 = Key_1                   }
	LEA	SI,Key_2   		{ DS:SI = Key_2                   }
	MOV	CX,1
	JMP	@@6
@@5:	INC	CX
@@6:    PUSH    CX
	{ Operations under Security Key                                   }
        { 56 bits shl ---> 56 bits                                        }
        MOV     AL,CL
        LEA     DI,LS
        LEA     SI,Key_2
        CALL    ShlKey                  { 56 bits shl ---> 56 bits        }
        MOV     AX,DS
        MOV     DX,OFFSET PC_2
        LEA     DI,Key_2
        LEA     SI,Key_3
        MOV     CL,48
        CALL    SwapBits                { 56 bits -------> 48 bits        }
        { Operations under main 64 bits block                             }
        MOV     AX,DS
        MOV     DX,OFFSET E
        LEA     DI,R0
        LEA     SI,RR
        MOV     CL,48
        CALL    SwapBits                { 32 bits -------> 48 bits        }
        MOV     BX,5                    { RR xor Key ----> RR             }
        LEA     DI,Key_3
        LEA     SI,RR
        JMP     @@8
@@7:    DEC     BX
@@8:    MOV     AL,BYTE PTR DS:[SI+BX]
        XOR     AL,BYTE PTR ES:[DI+BX]
        MOV     BYTE PTR DS:[SI+BX],AL
        CMP     BX,0
        JNE     @@7
        MOV     AX,DS
        MOV     DX,OFFSET StE
        LEA     DI,RR
        LEA     SI,SSS
        MOV     CL,64
        { R0 ---> RR  (i - 1 step)  and  Key_3  (i step)                  }
        CALL    SwapBits                { 48 bits -------> 64 bits        }
        MOV     BX,7                    { SS and 11111100 ----> SS        }
        LEA     DI,SSS
        JMP     @@10
@@9:    DEC     BX
@@10:   AND     BYTE PTR ES:[DI+BX],252 { 252d = 11111100b                }
        CMP     BX,0
        JNE     @@9
        LEA     DI,SSS
        LEA     SI,RF
        CALL    FuncDes
        MOV     BX,3                    { L0 xor RF -------> L0           }
        LEA     DI,RF
        LEA     SI,L0
        JMP     @@12
@@11:   DEC     BX
@@12:   MOV     AL,BYTE PTR DS:[SI+BX]
        XOR     AL,BYTE PTR ES:[DI+BX]
        MOV     BYTE PTR DS:[SI+BX],AL
        CMP     BX,0
        JNE     @@11
        LEA	DI,Key_1  		{ ES:DI = Key_1                   }
        LEA     SI,Key_2                { DS:SI = Key_2                   }
	MOV	CX,7
	REP	MOVSB           	{ Key_1 = Key_2                   }
        POP     CX
	CMP	CX,16
	JNE	@@5
	{ End of MAIN 16 times circle                                     }
        LEA     SI,AI
        MOV	BX,7
        JMP	@@14
@@13:   DEC	BX
@@14:	CMP	BX,3
	JBE	@@15
        LEA	DI,R0                   { Ri - second 4 Bytes             }
	MOV	DL,BYTE PTR ES:[DI+BX-4]
	MOV	BYTE PTR DS:[SI+BX],DL
	JMP	@@16
@@15:   LEA	DI,L0                   { Li - first  4 Bytes             }
        MOV	DL,BYTE PTR ES:[DI+BX]
	MOV	BYTE PTR DS:[SI+BX],DL
@@16:	CMP	BX,0
	JNE	@@13
        MOV     AX,DS
        MOV     DX,OFFSET IP_1
        LEA     DI,AI
        LDS     SI,OUT
        MOV     CL,64
        CALL    SwapBits
        POP     SI
        POP     DS
      end;

  BEGIN
  END.
